/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.openxma.dsl.dom.model;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Crud Operation Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.openxma.dsl.dom.DomPackage#getCrudOperationType()
 * @model
 * @generated
 */
public enum CrudOperationType implements Enumerator {
	/**
     * The '<em><b>NULL</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #NULL_VALUE
     * @generated
     * @ordered
     */
	NULL(0, "NULL", "NULL"), /**
     * The '<em><b>CREATE</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #CREATE_VALUE
     * @generated
     * @ordered
     */
	CREATE(1, "CREATE", "create"),

	/**
     * The '<em><b>READ</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #READ_VALUE
     * @generated
     * @ordered
     */
	READ(2, "READ", "read"),

	/**
     * The '<em><b>UPDATE</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #UPDATE_VALUE
     * @generated
     * @ordered
     */
	UPDATE(3, "UPDATE", "update"),

	/**
     * The '<em><b>DELETE</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #DELETE_VALUE
     * @generated
     * @ordered
     */
	DELETE(4, "DELETE", "delete"),

	/**
     * The '<em><b>ALL</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #ALL_VALUE
     * @generated
     * @ordered
     */
	ALL(5, "ALL", "crud");

	/**
     * The '<em><b>NULL</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>NULL</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #NULL
     * @model
     * @generated
     * @ordered
     */
	public static final int NULL_VALUE = 0;

	/**
     * The '<em><b>CREATE</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>CREATE</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #CREATE
     * @model literal="create"
     * @generated
     * @ordered
     */
	public static final int CREATE_VALUE = 1;

	/**
     * The '<em><b>READ</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>READ</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #READ
     * @model literal="read"
     * @generated
     * @ordered
     */
	public static final int READ_VALUE = 2;

	/**
     * The '<em><b>UPDATE</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>UPDATE</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #UPDATE
     * @model literal="update"
     * @generated
     * @ordered
     */
	public static final int UPDATE_VALUE = 3;

	/**
     * The '<em><b>DELETE</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>DELETE</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #DELETE
     * @model literal="delete"
     * @generated
     * @ordered
     */
	public static final int DELETE_VALUE = 4;

	/**
     * The '<em><b>ALL</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>ALL</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #ALL
     * @model literal="crud"
     * @generated
     * @ordered
     */
	public static final int ALL_VALUE = 5;

	/**
     * An array of all the '<em><b>Crud Operation Type</b></em>' enumerators.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private static final CrudOperationType[] VALUES_ARRAY =
		new CrudOperationType[] {
            NULL,
            CREATE,
            READ,
            UPDATE,
            DELETE,
            ALL,
        };

	/**
     * A public read-only list of all the '<em><b>Crud Operation Type</b></em>' enumerators.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static final List<CrudOperationType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
     * Returns the '<em><b>Crud Operation Type</b></em>' literal with the specified literal value.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static CrudOperationType get(String literal) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            CrudOperationType result = VALUES_ARRAY[i];
            if (result.toString().equals(literal)) {
                return result;
            }
        }
        return null;
    }

	/**
     * Returns the '<em><b>Crud Operation Type</b></em>' literal with the specified name.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static CrudOperationType getByName(String name) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            CrudOperationType result = VALUES_ARRAY[i];
            if (result.getName().equals(name)) {
                return result;
            }
        }
        return null;
    }

	/**
     * Returns the '<em><b>Crud Operation Type</b></em>' literal with the specified integer value.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static CrudOperationType get(int value) {
        switch (value) {
            case NULL_VALUE: return NULL;
            case CREATE_VALUE: return CREATE;
            case READ_VALUE: return READ;
            case UPDATE_VALUE: return UPDATE;
            case DELETE_VALUE: return DELETE;
            case ALL_VALUE: return ALL;
        }
        return null;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final int value;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final String name;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final String literal;

	/**
     * Only this class can construct instances.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private CrudOperationType(int value, String name, String literal) {
        this.value = value;
        this.name = name;
        this.literal = literal;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public int getValue() {
      return value;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String getName() {
      return name;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String getLiteral() {
      return literal;
    }

	/**
     * Returns the literal value of the enumerator, which is its string representation.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public String toString() {
        return literal;
    }
	
} //CrudOperationType
